// KEKS -- Go KEKS codec implementation
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package keks

import (
	"bytes"
	"testing"
)

func FuzzDecode(f *testing.F) {
	var err error
	var v any
	var buf bytes.Buffer
	var d *Decoder
	opts := DecodeOpts{MaxStrLen: 1 << 20}
	f.Fuzz(func(t *testing.T, b []byte) {
		d = NewDecoderFromBytes(b, &opts)
		_, err = d.Parse()
		if err == nil {
			v, err = d.Unmarshal()
			if err != nil {
				if err == ErrTAILeapSecond {
					return
				}
				t.Fatal(err)
			}
			buf.Reset()
			_, err = Encode(&buf, v, nil)
			if err != nil {
				t.Fatal(err)
			}
			if !bytes.Equal(buf.Bytes(), b[:buf.Len()]) {
				t.Fatal("not equal")
			}
		}
	})
}
